package modele.calculs;

import modele.donnees.*;

import java.awt.*;

/**
 * Controle4Directions permet d'appliquer une direction (connexion avec le clavier) à un ensemble d'entités dynamiques
 */
public class Controle4Directions extends RealisateurDeDeplacement {
    private Direction directionCourante;
    // Design pattern singleton
    private static Controle4Directions c3d;

    public static Controle4Directions getInstance() {
        if (c3d == null) {
            c3d = new Controle4Directions();
        }
        return c3d;
    }

    public void setDirectionCourante(Direction _directionCourante) {
        directionCourante = _directionCourante;
    }

    public boolean realiserDeplacement() {
        boolean ret = false;
        for (ElementDynamique e : lstEntitesDynamiques) {
            if (e instanceof Entite && directionCourante != null)
                switch (directionCourante) {
                    case gauche:
                    case droite:
                        if (e.avancerDirectionChoisie(directionCourante))
                            ret = true;
                        break;
                    case bas:
                    case haut:
                        ElementFond ef = ((Entite) e).regarderDerriereSoit();

                        if(ef != null && ef.peutPermettreDeMonterDescendre()) {
                            ret = e.avancerDirectionChoisie(directionCourante);
                        }
                        break;
                }
        }

        return ret;

    }

    public void resetDirection() {
        directionCourante = null;
    }
}
