package modele.calculs;

import modele.donnees.*;

public class Gravite extends RealisateurDeDeplacement {
    @Override
    public boolean realiserDeplacement() {
        boolean ret = false;

        for (ElementDynamique e : lstEntitesDynamiques) {
            if(e instanceof Entite) {
                ElementPhysique eBas = ((Entite) e).regarderDansLaDirection(Direction.bas);
                ElementFond eFond = ((Entite) e).regarderDerriereSoit();
                if (!(eFond != null && eFond.peutPermettreDeMonterDescendre())
                        && eBas == null || (eBas != null && !eBas.peutServirDeSupport())) {
                    if (e.avancerDirectionChoisie(Direction.bas))
                        ret = true;
                }
            }
        }

        return ret;
    }
}
