package modele.calculs;

import java.util.ArrayList;
import java.util.Observable;

import static java.lang.Thread.*;

public class Ordonnanceur extends Observable implements Runnable {
    private Jeu jeu;
    private ArrayList<RealisateurDeDeplacement> lstDeplacements = new ArrayList<RealisateurDeDeplacement>();
    private ArrayList<RealisateurDeDeplacement> buffer_lstDeplacements = new ArrayList<RealisateurDeDeplacement>();
    private long pause;
    public void add(RealisateurDeDeplacement deplacement) {
        buffer_lstDeplacements.add(deplacement);
    }
    private void addBuffer() {
        for (RealisateurDeDeplacement r : buffer_lstDeplacements)
            lstDeplacements.add(r);
        buffer_lstDeplacements.clear();
    }

    public Ordonnanceur(Jeu _jeu) {
        jeu = _jeu;
    }

    public void start(long _pause) {
        pause = _pause;
        new Thread(this).start();
    }

    @Override
    public void run() {
        boolean update = false;

        setChanged();
        notifyObservers();

        while(true) {
            switch (jeu.getState()) {
                case 0:
                    for (RealisateurDeDeplacement d : lstDeplacements) {
                        if (d.realiserDeplacement())
                            update = true;
                    }

                    MenuInput.getInstance().resetDirection();
                    break;
                case 3:
                case 4:
                    jeu.resetCmptDepl();
                    for (RealisateurDeDeplacement d : lstDeplacements) {
                        if (d.realiserDeplacement())
                            update = true;
                    }

                    Controle4Directions.getInstance().resetDirection();
                    break;
            }

            if (update) {
                setChanged();
                notifyObservers();
            }

            addBuffer();

            try {
                sleep(pause);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

    }
}
